package de.ozgcloud.apilib.common.callcontext;

import java.util.Optional;
import java.util.UUID;
import java.util.logging.Level;

import org.springframework.context.ApplicationContext;

import lombok.RequiredArgsConstructor;
import lombok.extern.java.Log;

@Log
@RequiredArgsConstructor
public class DefaultOzgCloudCallContextProvider implements OzgCloudCallContextProvider {

	private final ApplicationContext context;

	@Override
	public CallContext provideContext() {
		return CallContext.builder()
				.clientName(getClientName())
				.requestId(UUID.randomUUID().toString())
				.build();
	}

	private String getClientName() {
		return Optional.ofNullable(context.getId()).orElseGet(() -> {
			LOG.log(Level.WARNING, "No Client name given. Please configure 'spring.application.name'.");
			return "unkown_client";
		});

	}
}
