package de.ozgcloud.apilib.vorgang;

import java.time.ZonedDateTime;
import java.util.UUID;

import de.ozgcloud.apilib.user.OzgCloudUserId;

public class OzgCloudVorgangHeaderTestFactory {

	public static OzgCloudVorgangStatus STATUS = OzgCloudVorgangStatus.from("WORKING");
	public static String CREATED_AT_STR = "2023-04-01T10:00:15Z";
	public static ZonedDateTime CREATED_AT = ZonedDateTime.parse(CREATED_AT_STR);
	public static OzgCloudUserId ASSIGNED_TO = OzgCloudUserId.from(UUID.randomUUID().toString());
	public static String AKTENZEICHEN = "DE_12345_XY";

	public static OzgCloudVorgangHeader create() {
		return createBuilder().build();
	}

	public static OzgCloudVorgangHeader.OzgCloudVorgangHeaderBuilder createBuilder() {
		return OzgCloudVorgangHeader.builder()
				.status(STATUS)
				.createdAt(CREATED_AT)
				.assignedTo(ASSIGNED_TO)
				.aktenzeichen(AKTENZEICHEN);
	}
}
