package de.ozgcloud.apilib.vorgang.grpc;

import de.ozgcloud.vorgang.common.GrpcObject;
import de.ozgcloud.vorgang.common.GrpcProperty;
import de.ozgcloud.vorgang.vorgang.GrpcPostfachAddress;
import de.ozgcloud.vorgang.vorgang.GrpcServiceKonto;

public class GrpcServiceKontoTestFactory {

	public static final String TYPE = "OSI";
	public static final String VERSION = "1.0";

	public static GrpcServiceKonto create() {
		return createBuilder().build();
	}

	public static GrpcServiceKonto.Builder createBuilder() {
		return GrpcServiceKonto.newBuilder()
				.setType(TYPE)
				.addPostfachAddresses(GrpcPostfachAddress.newBuilder()
						.setVersion(VERSION)
						.setIdentifier(GrpcObject.newBuilder().addProperty(GrpcProperty.newBuilder()
								.setName("postfachId").addValue("0815").build())));
	}

}
